diff -NurpP --minimal linux-3.0/arch/cris/arch-v10/drivers/sync_serial.c torvalds-linux-v3.1-rc10/arch/cris/arch-v10/drivers/sync_serial.c
--- linux-3.0/arch/cris/arch-v10/drivers/sync_serial.c	2011-06-22 15:07:42.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/cris/arch-v10/drivers/sync_serial.c	2011-10-18 04:06:23.000000000 +0000
@@ -158,7 +158,7 @@ static int sync_serial_open(struct inode
 static int sync_serial_release(struct inode *inode, struct file *file);
 static unsigned int sync_serial_poll(struct file *filp, poll_table *wait);
 
-static int sync_serial_ioctl(struct file *file,
+static long sync_serial_ioctl(struct file *file,
 	unsigned int cmd, unsigned long arg);
 static ssize_t sync_serial_write(struct file *file, const char *buf,
 	size_t count, loff_t *ppos);
@@ -625,11 +625,11 @@ static int sync_serial_open(struct inode
 			*R_IRQ_MASK1_SET = 1 << port->data_avail_bit;
 		DEBUG(printk(KERN_DEBUG "sser%d rec started\n", dev));
 	}
-	ret = 0;
+	err = 0;
 	
 out:
 	mutex_unlock(&sync_serial_mutex);
-	return ret;
+	return err;
 }
 
 static int sync_serial_release(struct inode *inode, struct file *file)
diff -NurpP --minimal linux-3.0/arch/cris/arch-v10/kernel/entry.S torvalds-linux-v3.1-rc10/arch/cris/arch-v10/kernel/entry.S
--- linux-3.0/arch/cris/arch-v10/kernel/entry.S	2011-08-29 03:03:57.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/cris/arch-v10/kernel/entry.S	2011-10-18 04:06:23.000000000 +0000
@@ -771,7 +771,7 @@ sys_call_table:
 	.long sys_ni_syscall	/* sys_vm86 */
 	.long sys_ni_syscall	/* Old sys_query_module */
 	.long sys_poll
-	.long sys_nfsservctl
+	.long sys_ni_syscall    /* old nfsservctl */
 	.long sys_setresgid16	/* 170 */
 	.long sys_getresgid16
 	.long sys_prctl
diff -NurpP --minimal linux-3.0/arch/cris/arch-v10/kernel/irq.c torvalds-linux-v3.1-rc10/arch/cris/arch-v10/kernel/irq.c
--- linux-3.0/arch/cris/arch-v10/kernel/irq.c	2011-06-22 15:07:42.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/cris/arch-v10/kernel/irq.c	2011-10-18 04:06:23.000000000 +0000
@@ -20,6 +20,9 @@
 #define crisv10_mask_irq(irq_nr) (*R_VECT_MASK_CLR = 1 << (irq_nr));
 #define crisv10_unmask_irq(irq_nr) (*R_VECT_MASK_SET = 1 << (irq_nr));
 
+extern void kgdb_init(void);
+extern void breakpoint(void);
+
 /* don't use set_int_vector, it bypasses the linux interrupt handlers. it is
  * global just so that the kernel gdb can use it.
  */
diff -NurpP --minimal linux-3.0/arch/cris/arch-v32/drivers/cryptocop.c torvalds-linux-v3.1-rc10/arch/cris/arch-v32/drivers/cryptocop.c
--- linux-3.0/arch/cris/arch-v32/drivers/cryptocop.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/cris/arch-v32/drivers/cryptocop.c	2011-10-18 04:06:23.000000000 +0000
@@ -16,7 +16,7 @@
 
 #include <asm/uaccess.h>
 #include <asm/io.h>
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 
 #include <linux/list.h>
 #include <linux/interrupt.h>
diff -NurpP --minimal linux-3.0/arch/cris/arch-v32/kernel/entry.S torvalds-linux-v3.1-rc10/arch/cris/arch-v32/kernel/entry.S
--- linux-3.0/arch/cris/arch-v32/kernel/entry.S	2011-08-29 03:03:57.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/cris/arch-v32/kernel/entry.S	2011-10-18 04:06:23.000000000 +0000
@@ -714,7 +714,7 @@ sys_call_table:
 	.long sys_ni_syscall	/* sys_vm86 */
 	.long sys_ni_syscall	/* Old sys_query_module */
 	.long sys_poll
-	.long sys_nfsservctl
+	.long sys_ni_syscall	/* Old nfsservctl */
 	.long sys_setresgid16	/* 170 */
 	.long sys_getresgid16
 	.long sys_prctl
diff -NurpP --minimal linux-3.0/arch/cris/arch-v32/kernel/smp.c torvalds-linux-v3.1-rc10/arch/cris/arch-v32/kernel/smp.c
--- linux-3.0/arch/cris/arch-v32/kernel/smp.c	2011-08-29 03:03:57.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/cris/arch-v32/kernel/smp.c	2011-10-18 04:06:23.000000000 +0000
@@ -7,7 +7,7 @@
 #include <asm/mmu_context.h>
 #include <hwregs/asm/mmu_defs_asm.h>
 #include <hwregs/supp_reg.h>
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 
 #include <linux/err.h>
 #include <linux/init.h>
diff -NurpP --minimal linux-3.0/arch/cris/arch-v32/mach-a3/pinmux.c torvalds-linux-v3.1-rc10/arch/cris/arch-v32/mach-a3/pinmux.c
--- linux-3.0/arch/cris/arch-v32/mach-a3/pinmux.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/cris/arch-v32/mach-a3/pinmux.c	2011-10-18 04:06:23.000000000 +0000
@@ -85,6 +85,8 @@ crisv32_pinmux_alloc_fixed(enum fixed_fu
 	int ret = -EINVAL;
 	char saved[sizeof pins];
 	unsigned long flags;
+	reg_pinmux_rw_hwprot hwprot;
+	reg_clkgen_rw_clk_ctrl clk_ctrl;
 
 	spin_lock_irqsave(&pinmux_lock, flags);
 
@@ -93,9 +95,8 @@ crisv32_pinmux_alloc_fixed(enum fixed_fu
 
 	crisv32_pinmux_init(); /* must be done before we read rw_hwprot */
 
-	reg_pinmux_rw_hwprot hwprot = REG_RD(pinmux, regi_pinmux, rw_hwprot);
-	reg_clkgen_rw_clk_ctrl clk_ctrl = REG_RD(clkgen, regi_clkgen,
-		rw_clk_ctrl);
+	hwprot = REG_RD(pinmux, regi_pinmux, rw_hwprot);
+	clk_ctrl = REG_RD(clkgen, regi_clkgen, rw_clk_ctrl);
 
 	switch (function) {
 	case pinmux_eth:
@@ -262,6 +263,7 @@ crisv32_pinmux_dealloc_fixed(enum fixed_
 	int ret = -EINVAL;
 	char saved[sizeof pins];
 	unsigned long flags;
+	reg_pinmux_rw_hwprot hwprot;
 
 	spin_lock_irqsave(&pinmux_lock, flags);
 
@@ -270,7 +272,7 @@ crisv32_pinmux_dealloc_fixed(enum fixed_
 
 	crisv32_pinmux_init(); /* must be done before we read rw_hwprot */
 
-	reg_pinmux_rw_hwprot hwprot = REG_RD(pinmux, regi_pinmux, rw_hwprot);
+	hwprot = REG_RD(pinmux, regi_pinmux, rw_hwprot);
 
 	switch (function) {
 	case pinmux_eth:
diff -NurpP --minimal linux-3.0/arch/cris/include/arch-v10/arch/processor.h torvalds-linux-v3.1-rc10/arch/cris/include/arch-v10/arch/processor.h
--- linux-3.0/arch/cris/include/arch-v10/arch/processor.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/cris/include/arch-v10/arch/processor.h	2011-10-18 04:06:23.000000000 +0000
@@ -53,7 +53,6 @@ struct thread_struct {
  */
 
 #define start_thread(regs, ip, usp) do { \
-	set_fs(USER_DS);      \
 	regs->irp = ip;       \
 	regs->dccr |= 1 << U_DCCR_BITNR; \
 	wrusp(usp);           \
diff -NurpP --minimal linux-3.0/arch/cris/include/arch-v10/arch/ptrace.h torvalds-linux-v3.1-rc10/arch/cris/include/arch-v10/arch/ptrace.h
--- linux-3.0/arch/cris/include/arch-v10/arch/ptrace.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/cris/include/arch-v10/arch/ptrace.h	2011-10-18 04:06:23.000000000 +0000
@@ -112,7 +112,6 @@ struct switch_stack {
 #define user_mode(regs) (((regs)->dccr & 0x100) != 0)
 #define instruction_pointer(regs) ((regs)->irp)
 #define profile_pc(regs) instruction_pointer(regs)
-extern void show_regs(struct pt_regs *);
 
 #endif  /*  __KERNEL__  */
 
diff -NurpP --minimal linux-3.0/arch/cris/include/arch-v32/arch/processor.h torvalds-linux-v3.1-rc10/arch/cris/include/arch-v32/arch/processor.h
--- linux-3.0/arch/cris/include/arch-v32/arch/processor.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/cris/include/arch-v32/arch/processor.h	2011-10-18 04:06:23.000000000 +0000
@@ -47,7 +47,6 @@ struct thread_struct {
  */
 #define start_thread(regs, ip, usp) \
 do { \
-	set_fs(USER_DS); \
 	regs->erp = ip; \
 	regs->ccs |= 1 << (U_CCS_BITNR + CCS_SHIFT); \
 	wrusp(usp); \
diff -NurpP --minimal linux-3.0/arch/cris/include/arch-v32/arch/ptrace.h torvalds-linux-v3.1-rc10/arch/cris/include/arch-v32/arch/ptrace.h
--- linux-3.0/arch/cris/include/arch-v32/arch/ptrace.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/cris/include/arch-v32/arch/ptrace.h	2011-10-18 04:06:23.000000000 +0000
@@ -111,7 +111,6 @@ struct switch_stack {
 #define arch_has_single_step() (1)
 #define user_mode(regs) (((regs)->ccs & (1 << (U_CCS_BITNR + CCS_SHIFT))) != 0)
 #define instruction_pointer(regs) ((regs)->erp)
-extern void show_regs(struct pt_regs *);
 #define profile_pc(regs) instruction_pointer(regs)
 
 #endif  /*  __KERNEL__  */
diff -NurpP --minimal linux-3.0/arch/cris/include/asm/atomic.h torvalds-linux-v3.1-rc10/arch/cris/include/asm/atomic.h
--- linux-3.0/arch/cris/include/asm/atomic.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/cris/include/asm/atomic.h	2011-10-18 04:06:23.000000000 +0000
@@ -138,7 +138,7 @@ static inline int atomic_cmpxchg(atomic_
 
 #define atomic_xchg(v, new) (xchg(&((v)->counter), new))
 
-static inline int atomic_add_unless(atomic_t *v, int a, int u)
+static inline int __atomic_add_unless(atomic_t *v, int a, int u)
 {
 	int ret;
 	unsigned long flags;
@@ -148,9 +148,8 @@ static inline int atomic_add_unless(atom
 	if (ret != u)
 		v->counter += a;
 	cris_atomic_restore(v, flags);
-	return ret != u;
+	return ret;
 }
-#define atomic_inc_not_zero(v) atomic_add_unless((v), 1, 0)
 
 /* Atomic operations are already serializing */
 #define smp_mb__before_atomic_dec()    barrier()
@@ -158,5 +157,4 @@ static inline int atomic_add_unless(atom
 #define smp_mb__before_atomic_inc()    barrier()
 #define smp_mb__after_atomic_inc()     barrier()
 
-#include <asm-generic/atomic-long.h>
 #endif
diff -NurpP --minimal linux-3.0/arch/cris/include/asm/bitops.h torvalds-linux-v3.1-rc10/arch/cris/include/asm/bitops.h
--- linux-3.0/arch/cris/include/asm/bitops.h	2011-06-22 15:07:43.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/cris/include/asm/bitops.h	2011-10-18 04:06:23.000000000 +0000
@@ -20,7 +20,7 @@
 
 #include <arch/bitops.h>
 #include <asm/system.h>
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 #include <linux/compiler.h>
 
 /*
@@ -156,8 +156,7 @@ static inline int test_and_change_bit(in
 
 #include <asm-generic/bitops/le.h>
 
-#define ext2_set_bit_atomic(l,n,a)   test_and_set_bit(n,a)
-#define ext2_clear_bit_atomic(l,n,a) test_and_clear_bit(n,a)
+#include <asm-generic/bitops/ext2-atomic-setbit.h>
 
 #include <asm-generic/bitops/sched.h>
 
diff -NurpP --minimal linux-3.0/arch/cris/include/asm/serial.h torvalds-linux-v3.1-rc10/arch/cris/include/asm/serial.h
--- linux-3.0/arch/cris/include/asm/serial.h	1970-01-01 00:00:00.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/cris/include/asm/serial.h	2011-10-18 04:06:23.000000000 +0000
@@ -0,0 +1,9 @@
+#ifndef _ASM_SERIAL_H
+#define _ASM_SERIAL_H
+
+/*
+ * This assumes you have a 1.8432 MHz clock for your UART.
+ */
+#define BASE_BAUD (1843200 / 16)
+
+#endif /* _ASM_SERIAL_H */
diff -NurpP --minimal linux-3.0/arch/cris/include/asm/thread_info.h torvalds-linux-v3.1-rc10/arch/cris/include/asm/thread_info.h
--- linux-3.0/arch/cris/include/asm/thread_info.h	2011-06-22 15:07:43.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/cris/include/asm/thread_info.h	2011-10-18 04:06:23.000000000 +0000
@@ -11,8 +11,6 @@
 
 #ifdef __KERNEL__
 
-#define __HAVE_ARCH_THREAD_INFO_ALLOCATOR
-
 #ifndef __ASSEMBLY__
 #include <asm/types.h>
 #include <asm/processor.h>
@@ -67,8 +65,10 @@ struct thread_info {
 
 #define init_thread_info	(init_thread_union.thread_info)
 
+#define __HAVE_ARCH_THREAD_INFO_ALLOCATOR
 /* thread information allocation */
-#define alloc_thread_info(tsk, node) ((struct thread_info *) __get_free_pages(GFP_KERNEL,1))
+#define alloc_thread_info_node(tsk, node)	\
+	((struct thread_info *) __get_free_pages(GFP_KERNEL, 1))
 #define free_thread_info(ti) free_pages((unsigned long) (ti), 1)
 
 #endif /* !__ASSEMBLY__ */
diff -NurpP --minimal linux-3.0/arch/cris/kernel/module.c torvalds-linux-v3.1-rc10/arch/cris/kernel/module.c
--- linux-3.0/arch/cris/kernel/module.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/cris/kernel/module.c	2011-10-18 04:06:23.000000000 +0000
@@ -30,45 +30,19 @@
 #endif
 
 #ifdef CONFIG_ETRAX_KMALLOCED_MODULES
-#define MALLOC_MODULE(size) kmalloc(size, GFP_KERNEL)
-#define FREE_MODULE(region) kfree(region)
-#else
-#define MALLOC_MODULE(size) vmalloc_exec(size)
-#define FREE_MODULE(region) vfree(region)
-#endif
-
 void *module_alloc(unsigned long size)
 {
 	if (size == 0)
 		return NULL;
-	return MALLOC_MODULE(size);
+	return kmalloc(size, GFP_KERNEL);
 }
 
-
 /* Free memory returned from module_alloc */
 void module_free(struct module *mod, void *module_region)
 {
-	FREE_MODULE(module_region);
-}
-
-/* We don't need anything special. */
-int module_frob_arch_sections(Elf_Ehdr *hdr,
-			      Elf_Shdr *sechdrs,
-			      char *secstrings,
-			      struct module *mod)
-{
-	return 0;
-}
-
-int apply_relocate(Elf32_Shdr *sechdrs,
-		   const char *strtab,
-		   unsigned int symindex,
-		   unsigned int relsec,
-		   struct module *me)
-{
-	printk(KERN_ERR "module %s: REL relocation unsupported\n", me->name);
-	return -ENOEXEC;
+	kfree(module_region);
 }
+#endif
 
 int apply_relocate_add(Elf32_Shdr *sechdrs,
 		       const char *strtab,
@@ -108,14 +82,3 @@ int apply_relocate_add(Elf32_Shdr *sechd
 
 	return 0;
 }
-
-int module_finalize(const Elf_Ehdr *hdr,
-		    const Elf_Shdr *sechdrs,
-		    struct module *me)
-{
- 	return 0;
-}
-
-void module_arch_cleanup(struct module *mod)
-{
-}
diff -NurpP --minimal linux-3.0/arch/cris/kernel/process.c torvalds-linux-v3.1-rc10/arch/cris/kernel/process.c
--- linux-3.0/arch/cris/kernel/process.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/cris/kernel/process.c	2011-10-18 04:06:23.000000000 +0000
@@ -12,7 +12,7 @@
  * This file handles the architecture-dependent parts of process handling..
  */
 
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 #include <asm/pgtable.h>
 #include <asm/uaccess.h>
 #include <asm/irq.h>
diff -NurpP --minimal linux-3.0/arch/frv/Kconfig torvalds-linux-v3.1-rc10/arch/frv/Kconfig
--- linux-3.0/arch/frv/Kconfig	2011-08-29 03:03:57.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/frv/Kconfig	2011-10-18 04:06:23.000000000 +0000
@@ -7,6 +7,7 @@ config FRV
 	select HAVE_PERF_EVENTS
 	select HAVE_GENERIC_HARDIRQS
 	select GENERIC_IRQ_SHOW
+	select ARCH_HAVE_NMI_SAFE_CMPXCHG
 
 config ZONE_DMA
 	bool
diff -NurpP --minimal linux-3.0/arch/frv/include/asm/atomic.h torvalds-linux-v3.1-rc10/arch/frv/include/asm/atomic.h
--- linux-3.0/arch/frv/include/asm/atomic.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/frv/include/asm/atomic.h	2011-10-18 04:06:23.000000000 +0000
@@ -241,7 +241,7 @@ extern uint32_t __xchg_32(uint32_t i, vo
 #define atomic64_cmpxchg(v, old, new)	(__cmpxchg_64(old, new, &(v)->counter))
 #define atomic64_xchg(v, new)		(__xchg_64(new, &(v)->counter))
 
-static __inline__ int atomic_add_unless(atomic_t *v, int a, int u)
+static __inline__ int __atomic_add_unless(atomic_t *v, int a, int u)
 {
 	int c, old;
 	c = atomic_read(v);
@@ -253,10 +253,8 @@ static __inline__ int atomic_add_unless(
 			break;
 		c = old;
 	}
-	return c != (u);
+	return c;
 }
 
-#define atomic_inc_not_zero(v) atomic_add_unless((v), 1, 0)
 
-#include <asm-generic/atomic-long.h>
 #endif /* _ASM_ATOMIC_H */
diff -NurpP --minimal linux-3.0/arch/frv/include/asm/bitops.h torvalds-linux-v3.1-rc10/arch/frv/include/asm/bitops.h
--- linux-3.0/arch/frv/include/asm/bitops.h	2011-06-22 15:07:45.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/frv/include/asm/bitops.h	2011-10-18 04:06:23.000000000 +0000
@@ -403,8 +403,7 @@ int __ilog2_u64(u64 n)
 
 #include <asm-generic/bitops/le.h>
 
-#define ext2_set_bit_atomic(lock,nr,addr)	test_and_set_bit  ((nr) ^ 0x18, (addr))
-#define ext2_clear_bit_atomic(lock,nr,addr)	test_and_clear_bit((nr) ^ 0x18, (addr))
+#include <asm-generic/bitops/ext2-atomic-setbit.h>
 
 #endif /* __KERNEL__ */
 
diff -NurpP --minimal linux-3.0/arch/frv/include/asm/hardirq.h torvalds-linux-v3.1-rc10/arch/frv/include/asm/hardirq.h
--- linux-3.0/arch/frv/include/asm/hardirq.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/frv/include/asm/hardirq.h	2011-10-18 04:06:23.000000000 +0000
@@ -12,7 +12,7 @@
 #ifndef __ASM_HARDIRQ_H
 #define __ASM_HARDIRQ_H
 
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 
 extern atomic_t irq_err_count;
 static inline void ack_bad_irq(int irq)
diff -NurpP --minimal linux-3.0/arch/frv/include/asm/processor.h torvalds-linux-v3.1-rc10/arch/frv/include/asm/processor.h
--- linux-3.0/arch/frv/include/asm/processor.h	2011-06-22 15:07:45.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/frv/include/asm/processor.h	2011-10-18 04:06:23.000000000 +0000
@@ -97,7 +97,6 @@ extern struct task_struct *__kernel_curr
  */
 #define start_thread(_regs, _pc, _usp)			\
 do {							\
-	set_fs(USER_DS); /* reads from user space */	\
 	__frame = __kernel_frame0_ptr;			\
 	__frame->pc	= (_pc);			\
 	__frame->psr	&= ~PSR_S;			\
diff -NurpP --minimal linux-3.0/arch/frv/include/asm/ptrace.h torvalds-linux-v3.1-rc10/arch/frv/include/asm/ptrace.h
--- linux-3.0/arch/frv/include/asm/ptrace.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/frv/include/asm/ptrace.h	2011-10-18 04:06:23.000000000 +0000
@@ -78,7 +78,6 @@ register struct pt_regs *__frame asm("gr
 #define user_stack_pointer(regs)	((regs)->sp)
 
 extern unsigned long user_stack(const struct pt_regs *);
-extern void show_regs(struct pt_regs *);
 #define profile_pc(regs) ((regs)->pc)
 
 #define task_pt_regs(task) ((task)->thread.frame0)
diff -NurpP --minimal linux-3.0/arch/frv/kernel/entry.S torvalds-linux-v3.1-rc10/arch/frv/kernel/entry.S
--- linux-3.0/arch/frv/kernel/entry.S	2011-08-29 03:03:57.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/frv/kernel/entry.S	2011-10-18 04:06:23.000000000 +0000
@@ -1358,7 +1358,7 @@ sys_call_table:
 	.long sys_ni_syscall	/* for vm86 */
 	.long sys_ni_syscall	/* Old sys_query_module */
 	.long sys_poll
-	.long sys_nfsservctl
+	.long sys_ni_syscall	/* Old nfsservctl */
 	.long sys_setresgid16	/* 170 */
 	.long sys_getresgid16
 	.long sys_prctl
diff -NurpP --minimal linux-3.0/arch/frv/kernel/irq.c torvalds-linux-v3.1-rc10/arch/frv/kernel/irq.c
--- linux-3.0/arch/frv/kernel/irq.c	2011-06-22 15:07:46.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/frv/kernel/irq.c	2011-10-18 04:06:23.000000000 +0000
@@ -25,7 +25,7 @@
 #include <linux/module.h>
 #include <linux/bitops.h>
 
-#include <asm/atomic.h>
+#include <linux/atomic.h>
 #include <asm/io.h>
 #include <asm/smp.h>
 #include <asm/system.h>
diff -NurpP --minimal linux-3.0/arch/frv/kernel/module.c torvalds-linux-v3.1-rc10/arch/frv/kernel/module.c
--- linux-3.0/arch/frv/kernel/module.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/frv/kernel/module.c	2011-10-18 04:06:23.000000000 +0000
@@ -22,57 +22,6 @@
 #define DEBUGP(fmt...)
 #endif
 
-void *module_alloc(unsigned long size)
-{
-	if (size == 0)
-		return NULL;
-
-	return vmalloc_exec(size);
-}
-
-
-/* Free memory returned from module_alloc */
-void module_free(struct module *mod, void *module_region)
-{
-	vfree(module_region);
-}
-
-/* We don't need anything special. */
-int module_frob_arch_sections(Elf_Ehdr *hdr,
-			      Elf_Shdr *sechdrs,
-			      char *secstrings,
-			      struct module *mod)
-{
-	return 0;
-}
-
-int apply_relocate(Elf32_Shdr *sechdrs,
-		   const char *strtab,
-		   unsigned int symindex,
-		   unsigned int relsec,
-		   struct module *me)
-{
-	printk(KERN_ERR "module %s: ADD RELOCATION unsupported\n", me->name);
-	return -ENOEXEC;
-}
-
-int apply_relocate_add(Elf32_Shdr *sechdrs,
-		       const char *strtab,
-		       unsigned int symindex,
-		       unsigned int relsec,
-		       struct module *me)
-{
-	printk(KERN_ERR "module %s: ADD RELOCATION unsupported\n", me->name);
-	return -ENOEXEC;
-}
-
-int module_finalize(const Elf_Ehdr *hdr,
-		    const Elf_Shdr *sechdrs,
-		    struct module *me)
-{
-	return 0;
-}
-
-void module_arch_cleanup(struct module *mod)
-{
-}
+/* TODO: At least one of apply_relocate or apply_relocate_add must be
+ * implemented in order to get working module support.
+ */
diff -NurpP --minimal linux-3.0/arch/frv/kernel/process.c torvalds-linux-v3.1-rc10/arch/frv/kernel/process.c
--- linux-3.0/arch/frv/kernel/process.c	2011-06-22 15:07:46.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/frv/kernel/process.c	2011-10-18 04:06:23.000000000 +0000
@@ -143,10 +143,7 @@ void machine_power_off(void)
 
 void flush_thread(void)
 {
-#if 0 //ndef NO_FPU
-	unsigned long zero = 0;
-#endif
-	set_fs(USER_DS);
+	/* nothing */
 }
 
 inline unsigned long user_stack(const struct pt_regs *regs)
diff -NurpP --minimal linux-3.0/arch/frv/mm/pgalloc.c torvalds-linux-v3.1-rc10/arch/frv/mm/pgalloc.c
--- linux-3.0/arch/frv/mm/pgalloc.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/frv/mm/pgalloc.c	2011-10-18 04:06:23.000000000 +0000
@@ -133,13 +133,7 @@ void pgd_dtor(void *pgd)
 
 pgd_t *pgd_alloc(struct mm_struct *mm)
 {
-	pgd_t *pgd;
-
-	pgd = quicklist_alloc(0, GFP_KERNEL, pgd_ctor);
-	if (!pgd)
-		return pgd;
-
-	return pgd;
+	return quicklist_alloc(0, GFP_KERNEL, pgd_ctor);
 }
 
 void pgd_free(struct mm_struct *mm, pgd_t *pgd)
diff -NurpP --minimal linux-3.0/arch/h8300/Kconfig.cpu torvalds-linux-v3.1-rc10/arch/h8300/Kconfig.cpu
--- linux-3.0/arch/h8300/Kconfig.cpu	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/h8300/Kconfig.cpu	2011-10-18 04:06:23.000000000 +0000
@@ -162,9 +162,7 @@ config H8300_TPU_CH
 	int "TPU channel"
 	depends on H8300_TPU
 
-config PREEMPT
-	bool "Preemptible Kernel"
-	default n
+source "kernel/Kconfig.preempt"
 
 source "mm/Kconfig"
 
diff -NurpP --minimal linux-3.0/arch/h8300/include/asm/atomic.h torvalds-linux-v3.1-rc10/arch/h8300/include/asm/atomic.h
--- linux-3.0/arch/h8300/include/asm/atomic.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/h8300/include/asm/atomic.h	2011-10-18 04:06:23.000000000 +0000
@@ -104,7 +104,7 @@ static inline int atomic_cmpxchg(atomic_
 
 #define atomic_xchg(v, new) (xchg(&((v)->counter), new))
 
-static inline int atomic_add_unless(atomic_t *v, int a, int u)
+static inline int __atomic_add_unless(atomic_t *v, int a, int u)
 {
 	int ret;
 	unsigned long flags;
@@ -114,9 +114,8 @@ static inline int atomic_add_unless(atom
 	if (ret != u)
 		v->counter += a;
 	local_irq_restore(flags);
-	return ret != u;
+	return ret;
 }
-#define atomic_inc_not_zero(v) atomic_add_unless((v), 1, 0)
 
 static __inline__ void atomic_clear_mask(unsigned long mask, unsigned long *v)
 {
@@ -146,5 +145,4 @@ static __inline__ void atomic_set_mask(u
 #define smp_mb__before_atomic_inc()    barrier()
 #define smp_mb__after_atomic_inc() barrier()
 
-#include <asm-generic/atomic-long.h>
 #endif /* __ARCH_H8300_ATOMIC __ */
diff -NurpP --minimal linux-3.0/arch/h8300/include/asm/posix_types.h torvalds-linux-v3.1-rc10/arch/h8300/include/asm/posix_types.h
--- linux-3.0/arch/h8300/include/asm/posix_types.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/h8300/include/asm/posix_types.h	2011-10-18 04:06:23.000000000 +0000
@@ -50,7 +50,7 @@ typedef struct {
 #define	__FD_CLR(d, set)	((set)->fds_bits[__FDELT(d)] &= ~__FDMASK(d))
 
 #undef	__FD_ISSET
-#define	__FD_ISSET(d, set)	((set)->fds_bits[__FDELT(d)] & __FDMASK(d))
+#define	__FD_ISSET(d, set)	(!!((set)->fds_bits[__FDELT(d)] & __FDMASK(d)))
 
 #undef	__FD_ZERO
 #define __FD_ZERO(fdsetp) (memset (fdsetp, 0, sizeof(*(fd_set *)fdsetp)))
diff -NurpP --minimal linux-3.0/arch/h8300/include/asm/processor.h torvalds-linux-v3.1-rc10/arch/h8300/include/asm/processor.h
--- linux-3.0/arch/h8300/include/asm/processor.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/h8300/include/asm/processor.h	2011-10-18 04:06:23.000000000 +0000
@@ -81,7 +81,6 @@ struct thread_struct {
 #if defined(__H8300H__)
 #define start_thread(_regs, _pc, _usp)			        \
 do {							        \
-	set_fs(USER_DS);           /* reads from user space */  \
   	(_regs)->pc = (_pc);				        \
 	(_regs)->ccr = 0x00;	   /* clear all flags */        \
 	(_regs)->er5 = current->mm->start_data;	/* GOT base */  \
@@ -91,7 +90,6 @@ do {							        \
 #if defined(__H8300S__)
 #define start_thread(_regs, _pc, _usp)			        \
 do {							        \
-	set_fs(USER_DS);           /* reads from user space */  \
 	(_regs)->pc = (_pc);				        \
 	(_regs)->ccr = 0x00;	   /* clear kernel flag */      \
 	(_regs)->exr = 0x78;       /* enable all interrupts */  \
diff -NurpP --minimal linux-3.0/arch/h8300/include/asm/ptrace.h torvalds-linux-v3.1-rc10/arch/h8300/include/asm/ptrace.h
--- linux-3.0/arch/h8300/include/asm/ptrace.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/h8300/include/asm/ptrace.h	2011-10-18 04:06:23.000000000 +0000
@@ -60,7 +60,6 @@ struct pt_regs {
 #define user_mode(regs) (!((regs)->ccr & PS_S))
 #define instruction_pointer(regs) ((regs)->pc)
 #define profile_pc(regs) instruction_pointer(regs)
-extern void show_regs(struct pt_regs *);
 #endif /* __KERNEL__ */
 #endif /* __ASSEMBLY__ */
 #endif /* _H8300_PTRACE_H */
diff -NurpP --minimal linux-3.0/arch/h8300/kernel/module.c torvalds-linux-v3.1-rc10/arch/h8300/kernel/module.c
--- linux-3.0/arch/h8300/kernel/module.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/h8300/kernel/module.c	2011-10-18 04:06:23.000000000 +0000
@@ -11,40 +11,6 @@
 #define DEBUGP(fmt...)
 #endif
 
-void *module_alloc(unsigned long size)
-{
-	if (size == 0)
-		return NULL;
-	return vmalloc(size);
-}
-
-
-/* Free memory returned from module_alloc */
-void module_free(struct module *mod, void *module_region)
-{
-	vfree(module_region);
-}
-
-/* We don't need anything special. */
-int module_frob_arch_sections(Elf_Ehdr *hdr,
-			      Elf_Shdr *sechdrs,
-			      char *secstrings,
-			      struct module *mod)
-{
-	return 0;
-}
-
-int apply_relocate(Elf32_Shdr *sechdrs,
-		   const char *strtab,
-		   unsigned int symindex,
-		   unsigned int relsec,
-		   struct module *me)
-{
-	printk(KERN_ERR "module %s: RELOCATION unsupported\n",
-	       me->name);
-	return -ENOEXEC;
-}
-
 int apply_relocate_add(Elf32_Shdr *sechdrs,
 		       const char *strtab,
 		       unsigned int symindex,
@@ -107,14 +73,3 @@ int apply_relocate_add(Elf32_Shdr *sechd
 	       me->name, rela[i].r_offset);
 	return -ENOEXEC;
 }
-
-int module_finalize(const Elf_Ehdr *hdr,
-		    const Elf_Shdr *sechdrs,
-		    struct module *me)
-{
-	return 0;
-}
-
-void module_arch_cleanup(struct module *mod)
-{
-}
diff -NurpP --minimal linux-3.0/arch/h8300/kernel/setup.c torvalds-linux-v3.1-rc10/arch/h8300/kernel/setup.c
--- linux-3.0/arch/h8300/kernel/setup.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/h8300/kernel/setup.c	2011-10-18 04:06:23.000000000 +0000
@@ -46,7 +46,7 @@
 #include <asm/regs267x.h>
 #endif
 
-#define STUBSIZE 0xc000;
+#define STUBSIZE 0xc000
 
 unsigned long rom_length;
 unsigned long memory_start;
diff -NurpP --minimal linux-3.0/arch/h8300/kernel/syscalls.S torvalds-linux-v3.1-rc10/arch/h8300/kernel/syscalls.S
--- linux-3.0/arch/h8300/kernel/syscalls.S	2011-08-29 03:03:57.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/h8300/kernel/syscalls.S	2011-10-18 04:06:23.000000000 +0000
@@ -183,7 +183,7 @@ SYMBOL_NAME_LABEL(sys_call_table)
 	.long SYMBOL_NAME(sys_ni_syscall)	/* for vm86 */
 	.long SYMBOL_NAME(sys_ni_syscall)	/* sys_query_module */
 	.long SYMBOL_NAME(sys_poll)
-	.long SYMBOL_NAME(sys_nfsservctl)
+	.long SYMBOL_NAME(sys_ni_syscall)	/* old nfsservctl */
 	.long SYMBOL_NAME(sys_setresgid16)	/* 170 */
 	.long SYMBOL_NAME(sys_getresgid16)
 	.long SYMBOL_NAME(sys_prctl)
diff -NurpP --minimal linux-3.0/arch/ia64/Kconfig torvalds-linux-v3.1-rc10/arch/ia64/Kconfig
--- linux-3.0/arch/ia64/Kconfig	2011-08-29 03:03:57.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/ia64/Kconfig	2011-10-18 04:06:23.000000000 +0000
@@ -27,6 +27,8 @@ config IA64
 	select GENERIC_PENDING_IRQ if SMP
 	select IRQ_PER_CPU
 	select GENERIC_IRQ_SHOW
+	select ARCH_WANT_OPTIONAL_GPIOLIB
+	select ARCH_HAVE_NMI_SAFE_CMPXCHG
 	default y
 	help
 	  The Itanium Processor Family is Intel's 64-bit successor to
@@ -89,6 +91,9 @@ config GENERIC_TIME_VSYSCALL
 config HAVE_SETUP_PER_CPU_AREA
 	def_bool y
 
+config GENERIC_GPIO
+	def_bool y
+
 config DMI
 	bool
 	default y
@@ -101,6 +106,9 @@ config GENERIC_IOMAP
 	bool
 	default y
 
+config ARCH_CLOCKSOURCE_DATA
+	def_bool y
+
 config SCHED_OMIT_FRAME_POINTER
 	bool
 	default y
@@ -154,7 +162,6 @@ config IA64_GENERIC
 	select ACPI_NUMA
 	select SWIOTLB
 	select PCI_MSI
-	select DMAR
 	help
 	  This selects the system type of your hardware.  A "generic" kernel
 	  will run on any supported IA-64 system.  However, if you configure
@@ -627,27 +634,6 @@ source "drivers/pci/hotplug/Kconfig"
 
 source "drivers/pcmcia/Kconfig"
 
-config DMAR
-        bool "Support for DMA Remapping Devices (EXPERIMENTAL)"
-        depends on IA64_GENERIC && ACPI && EXPERIMENTAL
-	help
-	  DMA remapping (DMAR) devices support enables independent address
-	  translations for Direct Memory Access (DMA) from devices.
-	  These DMA remapping devices are reported via ACPI tables
-	  and include PCI device scope covered by these DMA
-	  remapping devices.
-
-config DMAR_DEFAULT_ON
-	def_bool y
-	prompt "Enable DMA Remapping Devices by default"
-	depends on DMAR
-	help
-	  Selecting this option will enable a DMAR device at boot time if
-	  one is found. If this option is not selected, DMAR support can
-	  be enabled by passing intel_iommu=on to the kernel. It is
-	  recommended you say N here while the DMAR code remains
-	  experimental.
-
 endmenu
 
 endif
@@ -681,6 +667,3 @@ source "lib/Kconfig"
 
 config IOMMU_HELPER
 	def_bool (IA64_HP_ZX1 || IA64_HP_ZX1_SWIOTLB || IA64_GENERIC || SWIOTLB)
-
-config IOMMU_API
-	def_bool (DMAR)
diff -NurpP --minimal linux-3.0/arch/ia64/include/asm/atomic.h torvalds-linux-v3.1-rc10/arch/ia64/include/asm/atomic.h
--- linux-3.0/arch/ia64/include/asm/atomic.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/ia64/include/asm/atomic.h	2011-10-18 04:06:23.000000000 +0000
@@ -90,7 +90,7 @@ ia64_atomic64_sub (__s64 i, atomic64_t *
 	(cmpxchg(&((v)->counter), old, new))
 #define atomic64_xchg(v, new) (xchg(&((v)->counter), new))
 
-static __inline__ int atomic_add_unless(atomic_t *v, int a, int u)
+static __inline__ int __atomic_add_unless(atomic_t *v, int a, int u)
 {
 	int c, old;
 	c = atomic_read(v);
@@ -102,10 +102,9 @@ static __inline__ int atomic_add_unless(
 			break;
 		c = old;
 	}
-	return c != (u);
+	return c;
 }
 
-#define atomic_inc_not_zero(v) atomic_add_unless((v), 1, 0)
 
 static __inline__ long atomic64_add_unless(atomic64_t *v, long a, long u)
 {
@@ -216,5 +215,4 @@ atomic64_add_negative (__s64 i, atomic64
 #define smp_mb__before_atomic_inc()	barrier()
 #define smp_mb__after_atomic_inc()	barrier()
 
-#include <asm-generic/atomic-long.h>
 #endif /* _ASM_IA64_ATOMIC_H */
diff -NurpP --minimal linux-3.0/arch/ia64/include/asm/bitops.h torvalds-linux-v3.1-rc10/arch/ia64/include/asm/bitops.h
--- linux-3.0/arch/ia64/include/asm/bitops.h	2011-06-22 15:07:46.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/ia64/include/asm/bitops.h	2011-10-18 04:06:23.000000000 +0000
@@ -458,8 +458,7 @@ static __inline__ unsigned long __arch_h
 
 #include <asm-generic/bitops/le.h>
 
-#define ext2_set_bit_atomic(l,n,a)	test_and_set_bit(n,a)
-#define ext2_clear_bit_atomic(l,n,a)	test_and_clear_bit(n,a)
+#include <asm-generic/bitops/ext2-atomic-setbit.h>
 
 #include <asm-generic/bitops/sched.h>
 
diff -NurpP --minimal linux-3.0/arch/ia64/include/asm/clocksource.h torvalds-linux-v3.1-rc10/arch/ia64/include/asm/clocksource.h
--- linux-3.0/arch/ia64/include/asm/clocksource.h	1970-01-01 00:00:00.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/ia64/include/asm/clocksource.h	2011-10-18 04:06:23.000000000 +0000
@@ -0,0 +1,10 @@
+/* IA64-specific clocksource additions */
+
+#ifndef _ASM_IA64_CLOCKSOURCE_H
+#define _ASM_IA64_CLOCKSOURCE_H
+
+struct arch_clocksource_data {
+	void *fsys_mmio;        /* used by fsyscall asm code */
+};
+
+#endif /* _ASM_IA64_CLOCKSOURCE_H */
